
Redmine - Defect #40860

Creating a new issue fails with an internal error if no issue priorities are defined

2024-06-19 18:21 - Holger Just

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 5.1.4   

Resolution: Fixed Affected version:  

Description

If no issue priority is defined, creating an issue using issue#create fails with the following error:

NoMethodError (undefined method `id' for nil:NilClass):

app/models/issue.rb:2075:in `clear_disabled_fields'

app/controllers/issues_controller.rb:153:in `create'

lib/redmine/sudo_mode.rb:78:in `sudo_mode'

 This can be fixed with the attached patch which results in a proper error message to be shown to the user:

Priority cannot be blank

 Unfortunately, this message is still shown even if the priority field is disabled for a tracker (as we still have to set a priority here, see 

#38416).

This may be acceptable as a uncommon special case though. If this shall be changed, we might handle this similar to the check for a

defined tracker and default status in IssueController#build_new_issue_from_params.

Related issues:

Related to Redmine - Feature #38416: Ability to disable the priority field Closed

Related to Redmine - Defect #38636: NoMethodError when creating/updating an i... Closed

Related to Redmine - Defect #42066: NoMethodError exception occurs in IssuePr... Closed

Has duplicate Redmine - Patch #40194: Fix error in clear_disabled_fields meth... Closed

Associated revisions

Revision 22895 - 2024-06-25 04:09 - Go MAEDA

Creating a new issue fails with an internal error if no issue priorities are defined (#40860).

Patch by Holger Just (@hjust).

Revision 22896 - 2024-06-25 04:15 - Go MAEDA

Add test for r22895 (#40860).

Revision 22900 - 2024-06-27 06:49 - Go MAEDA

Merged r22895 and r22896 from trunk to 5.1-stable (#40860).

History

#1 - 2024-06-19 18:23 - Holger Just

See Internal error after hitting issue create button (redmine... for the original description of this issue.

#2 - 2024-06-20 01:34 - Go MAEDA

- Target version changed from Candidate for next minor release to 5.0.10

#3 - 2024-06-20 13:22 - Go MAEDA

- Related to Feature #38416: Ability to disable the priority field added
https://www.redmine.org/issues/38416
https://www.redmine.org/boards/2/topics/69861


#4 - 2024-06-20 13:40 - Go MAEDA

- File test-for-40860.patch added

- Target version changed from 5.0.10 to 5.1.4

I wrote a test for the fix.

#5 - 2024-06-25 04:16 - Go MAEDA

- Subject changed from Creating a new issue fails with an internal eror if no issue priorities are defined to Creating a new issue fails with an internal

error if no issue priorities are defined

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r22895. Thank you.

#6 - 2024-06-27 06:50 - Go MAEDA

- Status changed from Resolved to Closed

Merged the fix into 5.1-stable in r22900.

#7 - 2024-06-27 11:33 - Holger Just

Thank you!

#8 - 2024-11-09 08:26 - Go MAEDA

- Has duplicate Patch #40194: Fix error in clear_disabled_fields method when IssuePriority is missing added

#9 - 2024-12-28 08:14 - Go MAEDA

- Related to Defect #38636: NoMethodError when creating/updating an issue if all issue priorities are disabled and no default priority is set added

#10 - 2025-01-04 08:36 - Go MAEDA

- Related to Defect #42066: NoMethodError exception occurs in IssuePriority#high and #low when both default and active priorities are absent added

Files

issue_priorities.diff 514 Bytes 2024-06-19 Holger Just

test-for-40860.patch 751 Bytes 2024-06-20 Go MAEDA
